347. 前 K 个高频元素【中等】

给你一个整数数组 nums 和一个整数 k ,请你返回其中出现频率前 k 高的元素。你可以按 任意顺序 返回答案。

示例 1:

**输入:**nums = 1,1,1,2,2,3, k = 2

输出:1,2

示例 2:

**输入:**nums = 1, k = 1

输出:1

示例 3:

**输入:**nums = 1,2,1,2,1,2,3,1,3,2, k = 2

输出:1,2

一、最小堆

思路:

这是一个Top K 问题 ,优先想到的就是使用最小堆/最大堆 ,使用优先级队列 PriorityQueue实现,PriorityQueue 虽然继承队列接口,但实际底层封装的是树结构,所以它满足堆的所有特性,它就是堆的具体实现。

我们首先创建一个哈希map,key存数组元素,value 存出现的频率,使用map辅助,一是能记录频率,二是能去重。再创建一个最小堆,用map 中的value 来排序。在遍历map 的键数组的过程中,让堆的大小为k,超出k 时移除堆顶元素,最后得到的堆就是包含前k 个高频元素的堆了。

时间复杂度O(n log k),因为堆是树结构,所以插入删除都是log k,当数组元素都不同时遍历耗时n

代码:

java 复制代码
class Solution {
    public int[] topKFrequent(int[] nums, int k) {
        // 使用map辅助,一是能记录频率,二是能去重
        Map<Integer, Integer> frequentMap = new HashMap<>();

        for(int num : nums){
            frequentMap.put(num, frequentMap.getOrDefault(num, 0) + 1);
        }

        PriorityQueue<Integer> minHeap = new PriorityQueue<>(
            (a, b) -> frequentMap.get(a) - frequentMap.get(b)
        );

        // map的keySet帮助去重了
        for(int num : frequentMap.keySet()){
            minHeap.offer(num);

            if(minHeap.size() > k){
                minHeap.poll(); 
            }
        }

        int[] reslut = new int[k];
        for(int i = 0; i < k; i++){
            reslut[i] = minHeap.poll();
        }
        
        return reslut;
    }
}
相关推荐
学不会pwn不改名6 分钟前
时间复杂度与空间复杂度详解
算法
AbandonForce17 分钟前
递归、搜索与回溯:从板书到二叉树解题方法
c++·算法·决策树
打工仔折腾 AI31 分钟前
让时序预测真正参与决策:TimechoAI 工程化落地与管线设计实践
人工智能·后端·python·算法·机器学习·性能优化
Light6035 分钟前
企业自建 AI 智能体,成本差 8 倍还是 46 倍?
java·人工智能·算法·知识图谱·rag·ai agent 上下文·token 成本
曹牧1 小时前
VS: Visual Studio 里把未包含的文件加进项目2
linux·运维·算法
重生之小比特1 小时前
【算法拾光】滑动窗口|长度最小的子数组 + 无重复字符的最长子串
算法
weixin_307779131 小时前
C++代码实现MATLAB中的fitnlm函数功能
开发语言·c++·算法·matlab
雪落漂泊1 小时前
C++算法:双指针篇(下)
数据结构·c++·算法
生态学者11 小时前
Global Change Biology | 森林越“步调一致”,反而越怕干旱?树木生长与叶片活动的同步之谜
大数据·人工智能·算法·r语言·微信公众平台